'  Blade Type of DLL Interface for Lame encoder
' 
'  Copyright (c) 1999-2002 A.L. Faber
    '  Based on bladedll.h version 1.0 written by Jukka Poikolainen
' 
'  This library is free software; you can redistribute it and/or
'  modify it under the terms of the GNU Lesser General Public
'  License as published by the Free Software Foundation; either
'  version 2 of the License, or (at your option) any later version.
'  
'  This library is distributed in the hope that it will be useful,
'  but WITHOUT ANY WARRANTY; without even the implied warranty of
'  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'  Lesser General Public License for more details.
'  
'  You should have received a copy of the GNU Lesser General Public
'  License along with this library; if not, write to the
'  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
'  Boston, MA  02111-1307, USA.
' *** adapted to FreeBasic by Electrik

#include "windows.bi" 
#inclib "lame_enc"
#ifndef __BLADEDLL_BI__
#define __BLADEDLL_BI__
#pragma once

'  
#define BE_CONFIG_MP3 0
#define BE_CONFIG_LAME			256

'  
type as dword HBE_STREAM
type as HBE_STREAM ptr PHBE_STREAM
type as dword BE_ERR

'  
#define  BE_ERR_SUCCESSFUL &h00000000
#define BE_ERR_INVALID_FORMAT &h00000001
#define		BE_ERR_INVALID_FORMAT_PARAMETERS &h00000002
#define		BE_ERR_NO_MORE_HANDLES &h00000003
#define		BE_ERR_INVALID_HANDLE &h00000004
#define		BE_ERR_BUFFER_TOO_SMALL &h00000005

'  
#define BE_MAX_HOMEPAGE 128

' format specific variables
#define BE_MP3_MODE_STEREO 0 '  
#define BE_MP3_MODE_JSTEREO 1 '  
#define BE_MP3_MODE_DUALCHANNEL 2 '  
#define BE_MP3_MODE_MONO 3 '  

#define MPEG1 1 '  
#define MPEG2 0 '  .     

#define CURRENT_STRUCT_VERSION 1
#define CURRENT_STRUCT_SIZE sizeof(BE_CONFIG)	' -    331 

enum VBRMETHOD
VBR_METHOD_NONE = -1 '   
VBR_METHOD_DEFAULT = 0
VBR_METHOD_OLD = 1
VBR_METHOD_NEW = 2
VBR_METHOD_MTRH = 3
VBR_METHOD_ABR = 4
end enum

enum LAME_QUALITY_PRESET
LQP_NOPRESET =-1 '    

'       
LQP_NORMAL_QUALITY = 0 '  
LQP_LOW_QUALITY = 1 '  
LQP_HIGH_QUALITY = 2 '  
LQP_VOICE_QUALITY = 3 '   
LQP_R3MIX = 4
LQP_VERYHIGH_QUALITY = 5 '   
LQP_STANDARD = 6 ' 
LQP_FAST_STANDARD = 7 ' ,  
LQP_EXTREME = 8 ' 
LQP_FAST_EXTREME = 9 ' ,  
LQP_INSANE = 10 '  
LQP_ABR = 11 ' average bytrate
LQP_CBR = 12 '  
LQP_MEDIUM = 13
LQP_FAST_MEDIUM = 14

'   
LQP_PHONE = 1000 '   
LQP_SW = 2000
LQP_AM = 3000 '   
LQP_FM = 4000 '   
LQP_VOICE = 5000 '  
LQP_RADIO = 6000 ' 
LQP_TAPE = 7000 '   
LQP_HIFI = 8000 '  
LQP_CD = 9000 '     
LQP_STUDIO = 10000 '  
end enum

			type MP3 field = 1 ' BE_CONFIG_MP3 
as dword dwSampleRate  '  48000, 44100  32000 
			as byte byMode  '  , BE_MP3_MODE_STEREO, BE_MP3_MODE_DUALCHANNEL, BE_MP3_MODE_MONO. . 
			as word wBitrate  '  32, 40, 48, 56, 64, 80, 96, 112, 128, 160, 192, 224, 256  320 
			as BOOL	bPrivate ' . 
as BOOL	bCRC '  
			as BOOL	bCopyright '  
			as BOOL	bOriginal 
end type 

type LHV1 field = 1 ' LAME header version 1 

		'   
			as dword			dwStructVersion '  
			as dword			dwStructSize '  

'   
			as dword			dwSampleRate		'     
			as dword			dwReSampleRate		' -  , 0= 
			as LONG			nMode				'  , BE_MP3_MODE_STEREO, BE_MP3_MODE_DUALCHANNEL, BE_MP3_MODE_MONO. . 
			as dword			dwBitrate			'   ,   
			as dword			dwMaxBitrate		'   ,    
			as LONG			nPreset			'      LAME_QUALITY_PRESET enum
			as dword			dwMpegVersion		'  mpeg. , MPEG-1   MPEG-2
			as dword			dwPsyModel			' FUTURE USE, SET TO 0
			as dword			dwEmphasis			' FUTURE USE, SET TO 0

'    
			as BOOL			SbPrivate			'    (TRUE/FALSE)
			as BOOL			IbCRC				'    (TRUE/FALSE)
			as BOOL			SbCopyright			'     (TRUE/FALSE)
			as BOOL			bOriginal			' Set Original Bit (TRUE/FALSE)
			
			' VBR STUFF
			as BOOL			bWriteVBRHeader	 ' WRITE XING VBR HEADER (TRUE/FALSE)
			as BOOL			bEnableVBR			'    (TRUE/FALSE)
			as INTEGER				nVBRQuality		'     0..9
			as dword			dwVbrAbr_bps		'  ABR  nVBRQuality
			as VBRMETHOD		nVbrMethod '  vbr
		as BOOL			bNoRes				' Disable Bit resorvoir (TRUE/FALSE)

			' MISC SETTINGS
			as BOOL			bStrictIso			' Use strict ISO encoding rules (TRUE/FALSE)
			as WORD			nQuality			'  , HIGH BYTE should be NOT LOW byte, otherwhise quality=5

			' FUTURE USE	, SET TO 0, align structure to 331 bytes
			as BYTE			btReserved(255-4*sizeof(dword) - sizeof( WORD )-1)
end type

type AAC  field = 1 ' aac
			as dword	dwSampleRate '  
		as BYTE	byMode '  
			as WORD	wBitrate ' 
			as BYTE	byEncodingMethod '  
end type

	union FORMAT field = 1 'format
as MP3 mp3
as LHV1 lhv1
as AAC aac
end union

type BE_CONFIG field = 1
	as dword dwConfig  ' BE_CONFIG_XXXXX
'  BE_CONFIG

as FORMAT format
end type

		
  type as BE_CONFIG ptr PBE_CONFIG


type BE_VERSION

	' BladeEnc DLL  
	as BYTE	byDLLMajorVersion
	as BYTE	byDLLMinorVersion

	' BladeEnc    (engine)
	as BYTE	byMajorVersion
	as BYTE	byMinorVersion

	'   DLL 
	as BYTE	byDay	
as BYTE	byMonth
	as WORD	wYear

	'BladeEnc	 
	as zstring * BE_MAX_HOMEPAGE + 1 zHomepage

	as BYTE	byAlphaLevel
	as BYTE	byBetaLevel
	as BYTE	byMMXEnabled

	as BYTE	btReserved(125-1)
end type

type as BE_VERSION ptr PBE_VERSION

extern "c"

'   
declare function beInitStream alias "beInitStream" _
(byval pbeConfig as PBE_CONFIG, byval dwSamples as PDWORD, _
byval dwBufferSize as PDWORD, byval phbeStream as PHBE_STREAM) as BE_ERR

'    
declare function beEncodeChunk alias "beEncodeChunk" _
(byval hbeStream as HBE_STREAM, byval nSamples as DWORD, _
byval pSamples as PSHORT, byval pOutput as PBYTE, _
byval pdwOutput as PDWORD )as BE_ERR

'added for floating point audio  -- DSPguru, jd
declare function beEncodeChunkFloatS16NI alias "beEncodeChunkFloatS16NI" _
(byval hbeStream as HBE_STREAM, byval nSamples as DWORD, _
byval buffer_l as PFLOAT, byval buffer_r as PFLOAT, _
byval pOutput as PBYTE, byval pdwOutput as PDWORD) as BE_ERR

'   
declare function beDeinitStream alias "beDeinitStream" _
(byval hbeStream as HBE_STREAM, byval pOutput as PBYTE, _
byval pdwOutput as PDWORD) as BE_ERR

'   
declare function beCloseStream alias "beCloseStream" _
(byval hbeStream as HBE_STREAM) as BE_ERR

'    
declare function beVersion alias "beVersion" _
(byval pbeVersion as PBE_VERSION) as PCVOID

declare function beWriteVBRHeader alias "beWriteVBRHeader" _
(byval lpszFileName as LPCSTR) as BE_ERR
declare function beFlushNoGap alias "beFlushNoGap" _
(byval hbeStream as HBE_STREAM, byval pOutput as PBYTE, _
byval pdwOutput as PDWORD) as BE_ERR
declare function beWriteInfoTag alias "beWriteInfoTag" _
(byval hbeStream as HBE_STREAM, byval lpszFileName as LPCSTR) as BE_ERR
end extern
#endif
